# coding: utf-8

"""
FastAPI

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 0.1.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import TYPE_CHECKING, Any, Dict, List, Optional, Union

from truefoundry.ml.autogen.client.models.agent import Agent
from truefoundry.ml.autogen.client.models.agent_open_api_tool import AgentOpenAPITool
from truefoundry.ml.autogen.client.models.chat_prompt import ChatPrompt
from truefoundry.pydantic_v1 import (
    BaseModel,
    Field,
    ValidationError,
    validator,
)

INTERNALMETADATA_ANY_OF_SCHEMAS = ["Agent", "AgentOpenAPITool", "ChatPrompt", "object"]


class InternalMetadata(BaseModel):
    """
    InternalMetadata
    """

    # data type: ChatPrompt
    anyof_schema_1_validator: Optional[ChatPrompt] = None
    # data type: AgentOpenAPITool
    anyof_schema_2_validator: Optional[AgentOpenAPITool] = None
    # data type: Agent
    anyof_schema_3_validator: Optional[Agent] = None
    # data type: object
    anyof_schema_4_validator: Optional[Dict[str, Any]] = None
    if TYPE_CHECKING:
        actual_instance: Union[Agent, AgentOpenAPITool, ChatPrompt, object]
    else:
        actual_instance: Any
    any_of_schemas: List[str] = Field(INTERNALMETADATA_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError(
                    "If a position argument is used, only 1 is allowed to set `actual_instance`"
                )
            if kwargs:
                raise ValueError(
                    "If a position argument is used, keyword arguments cannot be used."
                )
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator("actual_instance")
    def actual_instance_must_validate_anyof(cls, v):
        instance = InternalMetadata.construct()
        error_messages = []
        # validate data type: ChatPrompt
        if not isinstance(v, ChatPrompt):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ChatPrompt`")
        else:
            return v

        # validate data type: AgentOpenAPITool
        if not isinstance(v, AgentOpenAPITool):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `AgentOpenAPITool`"
            )
        else:
            return v

        # validate data type: Agent
        if not isinstance(v, Agent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Agent`")
        else:
            return v

        # validate data type: object
        try:
            instance.anyof_schema_4_validator = v
            return v
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        if error_messages:
            # no match
            raise ValueError(
                "No match found when setting the actual_instance in InternalMetadata with anyOf schemas: Agent, AgentOpenAPITool, ChatPrompt, object. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> InternalMetadata:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> InternalMetadata:
        """Returns the object represented by the json string"""
        instance = InternalMetadata.construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[ChatPrompt] = None
        try:
            instance.actual_instance = ChatPrompt.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[AgentOpenAPITool] = None
        try:
            instance.actual_instance = AgentOpenAPITool.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[Agent] = None
        try:
            instance.actual_instance = Agent.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into object
        try:
            # validation
            instance.anyof_schema_4_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.anyof_schema_4_validator
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into InternalMetadata with anyOf schemas: Agent, AgentOpenAPITool, ChatPrompt, object. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())
